#!/usr/bin/perl
#
# room.pl - Compute room for images in chip
#
# Written 2006 by Werner Almesberger
# Copyright 2006 Werner Almesberger
#


sub calc
{
    local $chip = $_[0];

    $s = $size-$shrink;
    if ($chip eq "ATmega48") {
	$flash = 4096;
    }
    elsif ($chip eq "ATmega88") {
	$flash = 8192;
    }
    elsif ($chip eq "ATmega168") {
	$flash = 16384;
	$s += 200;
    }
    else {
	die;
    }
    print sprintf("%s: (%d-%d-2)/(3*24+4) = %f\n",$chip,$flash,$s,
     ($flash-$s-2)/(3*24+4));
}


sub usage
{
    print STDERR "usage: $0 chip-name firmware-file\n\n";
    print STDERR "chip-name: ATmega48, ATmega88, or ATmega168\n";
    print STDERR "firmware-file: e.g., fw-LTA24V0.bin\n";
    exit(1);
}


&usage unless $#ARGV == 1;

if ($ARGV[0] eq "ATmega48") {
    $shrink = 0;
}
elsif ($ARGV[0] eq "ATmega88") {
    $shrink = 0;
}
elsif ($ARGV[0] eq "ATmega168") {
    $shrink = 200;
}
else {
    &usage;
}

die "$ARGV[1]: $!" unless -f $ARGV[1];

$size = -s $ARGV[1];

&calc("ATmega48");
&calc("ATmega88");
&calc("ATmega168");
